> For the complete documentation index, see [llms.txt](https://docs.finpay.id/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.finpay.id/api-reference/finpay-pg/core-api/qris.md).

# QRIS

QRIS (Quick Response Code Indonesian Standard) is standardization of payments using the QR Code method from Bank Indonesia and can be scanned / recognized / read by the Payment System Service Provider so that the transaction process with QR Code becomes easier, faster, and safe.

### Technical Specification <a href="#technical-specification" id="technical-specification"></a>

| Environment | Method | URL                                                  |
| ----------- | ------ | ---------------------------------------------------- |
| Development | POST   | <https://devo.finnet.co.id/pg/payment/card/initiate> |
| Production  | POST   | <https://live.finnet.co.id/pg/payment/card/initiate> |

### Body Request <a href="#body-request" id="body-request"></a>

| No | Name          | Type                                                                    | Mandatory | Min Length | Max Length | Description             |
| -- | ------------- | ----------------------------------------------------------------------- | --------- | ---------- | ---------- | ----------------------- |
| 1  | order         | [Object](/api-reference/appendix/json-object/order-object.md)           | O         | 1          | 12         | Detail of Order         |
| 2  | customer      | [Object](/api-reference/appendix/json-object/customer-object.md)        | M         | 1          | 8          | Detail of Customer      |
| 3  | url           | [Object](/api-reference/appendix/json-object/url-object.md)             | O         | 1          | 4          | Detail of Url           |
| 4  | billing       | [Object](/api-reference/appendix/json-object/billing-object.md)         | O         | 1          | 1          | Detail of Billing       |
| 5  | shipping      | [Object](/api-reference/appendix/json-object/shipping-object.md)        | O         | 1          | 4          | Detail of Shipping      |
| 6  | meta          | [Object](/api-reference/appendix/json-object/meta-object.md)            | O         | 1          | 1          | Detail of MetaData      |
| 7  | card          | [Object](/api-reference/appendix/json-object/card-object.md)            | O         | 1          | 7          | Detail of Card          |
| 8  | recurring     | [Object](/api-reference/appendix/json-object/recurring-object.md)       | O         | 1          | 11         | Detail of Recurring     |
| 9  | sourceOfFunds | [Object](/api-reference/appendix/json-object/source-of-funds-object.md) | M         | 1          | 11         | Detail of SourceOfFunds |
| 10 | device        | [Object](/api-reference/appendix/json-object/device-object.md)          | O         | 1          | 7          | Detail of Device        |

#### Sample Request <a href="#sample-request" id="sample-request"></a>

```
{
  "customer": {
    "email": "hajar.finnet@gmail.com",
    "firstName": "Hajar",
    "lastName": "Ismail",
    "mobilePhone": "+6281286288844"
  },
  "order": {
    "id": "1680679096364",
    "amount": "1000",
    "description": "Testing"
  },
  "url": {
    "callbackUrl": "https://sandbox.finpay.co.id/simdev/finpay/result/resultsuccess.php"
  },
  "sourceOfFunds": {
    "type": "qris"
  }
}
```

### Body Response <a href="#body-response" id="body-response"></a>

| No | Name            | Type                                                              | Mandatory | Min Length | Max Length | Description      |
| -- | --------------- | ----------------------------------------------------------------- | --------- | ---------- | ---------- | ---------------- |
| 1  | responseCode    | [Enum](/api-reference/appendix/enumeration/response-code-list.md) | M         | 1          | 7          | Response Code    |
| 2  | responseMessage | String                                                            | M         | 1          | 500        | Response Message |
| 3  | paymentCode     | String                                                            | C         | 1          | 30         | Payment Code     |
| 4  | redirecturl     | String                                                            | C         | 1          | 320        | Redirect URL     |
| 5  | expiryLink      | String                                                            | C         | 1          | 19         | Expiry Link      |
| 6  | processingTime  | Number                                                            | C         | 1          | 20         | Processing Time  |
| 7  | appurl          | String                                                            | C         | 1          | 320        | App URL          |
| 8  | imageurl        | String                                                            | C         | 1          | 320        | Image URL        |
| 9  | accountList     | Array                                                             | C         | 1          | 4          | Account List     |

#### Sample Response <a href="#sample-response" id="sample-response"></a>

```
{
  "responseCode": "2000000",
  "responseMessage": "Success",
  "redirecturl": "",
  "appurl": "",
  "imageurl": "https://devo.finpay.id/pg/payment/card/v2/access/17d6a417565a51e792c64a7f4b4b1e833743ceea6b93b6c7a5ee29e12ae980b1",
  "expiryLink": "2023-11-23 14:37:53",
  "paymentCode": "",
  "stringQr": "00020101021226570013ID.FINPAY.WWW01189360077732007220010207ZORA4840303UKE51410014ID.CO.QRIS.WWW0212ID12345678910303UKE52045814530336054062014105802ID5909PT Finnet6007Jakarta6105127106220071640788317006386736304F850",
  "processingTime": 0.28851914405822754
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.finpay.id/api-reference/finpay-pg/core-api/qris.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
